#global candidate rc5
%if 0%{?rhel}
%bcond_with toolsonly
%else
%bcond_without toolsonly
%endif

Name:     uboot-tools
Version:  2024.04
Release:  4%{?candidate:.%{candidate}}%{?dist}
Epoch:    1
Summary:  U-Boot utilities
License:  GPLv2+ BSD LGPL-2.1+ LGPL-2.0+
URL:      http://www.denx.de/wiki/U-Boot

ExcludeArch: s390x
Source0:  https://ftp.denx.de/pub/u-boot/u-boot-%{version}%{?candidate:-%{candidate}}.tar.bz2
Source1:  aarch64-boards

# This is now legacy, most devices use bootflow, we keep this for the laggards
Patch1:   uefi-distro-load-FDT-from-any-partition-on-boot-device.patch
# Identify VFAT partitions as ESP, allows EFI setvar on our images
Patch2:   uefi-Add-all-options-for-EFI-System-Partitions.patch
# New function to find fdt for loading from disk
Patch3:   uefi-initial-find_fdt_location-for-finding-the-DT-on-disk.patch
# Fedora patches to enable/disable features
Patch4:   disable-VBE-by-default.patch
Patch5:   enable-bootmenu-by-default.patch
# Should be upstream but it's taking time
Patch6:   Add-video-damage-tracking.patch

# Board fixes and enablement
# RPi - uses RPI firmware device tree for HAT support
Patch10:  rpi-Switch-to-OF_HAS_PRIOR_STAGE-by-default.patch
# Rockchips improvements
Patch11:  rockchip-Add-initial-support-for-the-PinePhone-Pro.patch
Patch12:  rockchip-Enable-preboot-start-for-pci-usb.patch
Patch13:  phy-rockchip-inno-usb2-Write-to-correct-GRF.patch
Patch14:  rockchip-Migrate-to-use-DM_USB_GADGET-on-RK3328.patch

# Asahi patches from gen-asahi-patches.sh
# input: apple: Split off report handling into a separate file
Patch100: https://github.com/AsahiLinux/u-boot/commit/0587b000a7099615e63b2c56ee918d542ba3c101.patch#/asahi-0587b000a7099615e63b2c56ee918d542ba3c101.patch
# arm: apple: rtkit: Add support for AP power & syslogs
Patch101: https://github.com/AsahiLinux/u-boot/commit/61c6e4d5300f5b534d71acbc83915b9890990b26.patch#/asahi-61c6e4d5300f5b534d71acbc83915b9890990b26.patch
# arm: apple: rtkit: Add default buffer handlers
Patch102: https://github.com/AsahiLinux/u-boot/commit/fecae0a08afbe2b6a3330edadc393e2700d2cd76.patch#/asahi-fecae0a08afbe2b6a3330edadc393e2700d2cd76.patch
# arm: apple: rtkit: Add a generic RTKit helper driver
Patch103: https://github.com/AsahiLinux/u-boot/commit/4d9899554f29141681473436d7b18d76ddbfcff8.patch#/asahi-4d9899554f29141681473436d7b18d76ddbfcff8.patch
# input: apple: Add support for Apple MTP keyboard
Patch104: https://github.com/AsahiLinux/u-boot/commit/3c3f9d87a8a39c7ac47270c1c2c9cf7c144c6803.patch#/asahi-3c3f9d87a8a39c7ac47270c1c2c9cf7c144c6803.patch
# arm: apple: Add MTP keyboard options to defconfig
Patch105: https://github.com/AsahiLinux/u-boot/commit/23b17d3ad906f55e4c7b5b74fbb462a6e08383ee.patch#/asahi-23b17d3ad906f55e4c7b5b74fbb462a6e08383ee.patch
# apple: Set up file system firmware loader
Patch106: https://github.com/AsahiLinux/u-boot/commit/98d4b5c8d44e539f06dc654e92acdc51ae533876.patch#/asahi-98d4b5c8d44e539f06dc654e92acdc51ae533876.patch
# iopoll: Add readb_poll_sleep_timeout
Patch107: https://github.com/AsahiLinux/u-boot/commit/b8b19b0f6bc574dc2ed274c8589371e24518dbe0.patch#/asahi-b8b19b0f6bc574dc2ed274c8589371e24518dbe0.patch
# usb: xhci-pci: Load ASMedia XHCI controller firmware
Patch108: https://github.com/AsahiLinux/u-boot/commit/acfcbb1ec414288363cfc4d76e856164c4de619a.patch#/asahi-acfcbb1ec414288363cfc4d76e856164c4de619a.patch
# env: apple: Enable ENV_IS_IN_FAT
Patch109: https://github.com/AsahiLinux/u-boot/commit/137fcf543673d28cb708e7e32edf35d16949ac3b.patch#/asahi-137fcf543673d28cb708e7e32edf35d16949ac3b.patch
# apple: Nail down the EFI system partition
Patch110: https://github.com/AsahiLinux/u-boot/commit/fc674bc74d870d2a00b6b8d140aa8a22b76198e5.patch#/asahi-fc674bc74d870d2a00b6b8d140aa8a22b76198e5.patch
# scripts/dtc: Add support for floating-point literals
Patch111: https://github.com/AsahiLinux/u-boot/commit/ae70c3fc84a27b0d20ec035decb0ba34dd2dfce7.patch#/asahi-ae70c3fc84a27b0d20ec035decb0ba34dd2dfce7.patch
# arm: dts: apple: Update Apple M1 device trees
Patch112: https://github.com/AsahiLinux/u-boot/commit/89a4e6e2d1b5e329ae71962e5361c33fe3f5d513.patch#/asahi-89a4e6e2d1b5e329ae71962e5361c33fe3f5d513.patch
# arm: dts: apple: Add Apple M1 Pro/Max/Ultra device trees
Patch113: https://github.com/AsahiLinux/u-boot/commit/b25be9b607bd835e4bcb215f62275304365851f5.patch#/asahi-b25be9b607bd835e4bcb215f62275304365851f5.patch
# arm: dts: apple: Add Apple M2 device trees
Patch114: https://github.com/AsahiLinux/u-boot/commit/b7a742b095a9a7efd38bf4a5b51712afd3eb6afb.patch#/asahi-b7a742b095a9a7efd38bf4a5b51712afd3eb6afb.patch
# arm: dts: apple: Add Apple M2 Pro/Max device trees
Patch115: https://github.com/AsahiLinux/u-boot/commit/5de20e4ce121295f21b15884814f97d467c28e69.patch#/asahi-5de20e4ce121295f21b15884814f97d467c28e69.patch
# arm: apple: rtkit: Add OSLog buffer support
Patch116: https://github.com/AsahiLinux/u-boot/commit/3628881711780c55cd52d725596653fcb2f9da61.patch#/asahi-3628881711780c55cd52d725596653fcb2f9da61.patch
# arm: apple: rtkit: Add endpoint field to buffers
Patch117: https://github.com/AsahiLinux/u-boot/commit/dd5e1474496f61290afe1190033fafa33fd960a5.patch#/asahi-dd5e1474496f61290afe1190033fafa33fd960a5.patch
# arm: apple: rtkit: Support allocating OSLog out of SRAM in helper
Patch118: https://github.com/AsahiLinux/u-boot/commit/728a29bd04e5c3e831b3bfa2c77bd17f4acf2558.patch#/asahi-728a29bd04e5c3e831b3bfa2c77bd17f4acf2558.patch
# efi_loader: prefer EFI system partition
Patch119: https://github.com/AsahiLinux/u-boot/commit/d7e4e6ea93aa28112c2222375bd5defa4d1e5859.patch#/asahi-d7e4e6ea93aa28112c2222375bd5defa4d1e5859.patch
# apple_m1_defconfig: Disable EFI variable store
Patch120: https://github.com/AsahiLinux/u-boot/commit/8fadf9c3fcd6ee0aa050728f43fbb8613c1bb6a3.patch#/asahi-8fadf9c3fcd6ee0aa050728f43fbb8613c1bb6a3.patch
# usb: xhci: Add more debugging
Patch121: https://github.com/AsahiLinux/u-boot/commit/b1ce542a988bff5ec00c11e94694fe9dc835720f.patch#/asahi-b1ce542a988bff5ec00c11e94694fe9dc835720f.patch
# usb: storage: Clear endpoint stalls properly
Patch122: https://github.com/AsahiLinux/u-boot/commit/9e20a4440c820238d42daee16efc3e945b690137.patch#/asahi-9e20a4440c820238d42daee16efc3e945b690137.patch
# usb: Pass through timeout to drivers
Patch123: https://github.com/AsahiLinux/u-boot/commit/595e53251082267051a74e587a678a96eb2501d5.patch#/asahi-595e53251082267051a74e587a678a96eb2501d5.patch
# usb: xhci: Hook up timeouts
Patch124: https://github.com/AsahiLinux/u-boot/commit/d6db2289c97057998a867ee5cd7408725603fbd9.patch#/asahi-d6db2289c97057998a867ee5cd7408725603fbd9.patch
# scsi: Fix a bunch of SCSI definitions.
Patch125: https://github.com/AsahiLinux/u-boot/commit/f8fef2adb09ad5a8a57f349f37bb9dcaf4a8ef7d.patch#/asahi-f8fef2adb09ad5a8a57f349f37bb9dcaf4a8ef7d.patch
# usb: storage: Increase read/write timeout
Patch126: https://github.com/AsahiLinux/u-boot/commit/69403231cf73778bf89ff209a6ecb24cd6ffaf0d.patch#/asahi-69403231cf73778bf89ff209a6ecb24cd6ffaf0d.patch
# usb: storage: Implement 64-bit LBA support
Patch127: https://github.com/AsahiLinux/u-boot/commit/d83405bc3b58d05d564da34a31f4478fe80c7cfc.patch#/asahi-d83405bc3b58d05d564da34a31f4478fe80c7cfc.patch
# usb: Ignore endpoints in non-zero altsettings
Patch128: https://github.com/AsahiLinux/u-boot/commit/67468b21570d9f37a95675d2395bf14bfbbf35e7.patch#/asahi-67468b21570d9f37a95675d2395bf14bfbbf35e7.patch
# apple_m1_defconfig: Turn on CONFIG_SYS_64BIT_LBA
Patch129: https://github.com/AsahiLinux/u-boot/commit/fb94053943a691fb0c4c14cd1e4bf199215f0d9b.patch#/asahi-fb94053943a691fb0c4c14cd1e4bf199215f0d9b.patch
# configs: apple: Use "vidconsole,serial" as stdout/stderr
Patch130: https://github.com/AsahiLinux/u-boot/commit/e592332e207c8cf88308b190464464bb08e0c13e.patch#/asahi-e592332e207c8cf88308b190464464bb08e0c13e.patch
# configs: apple: Enable CMD_SELECT_FONT and FONT_16X32
Patch131: https://github.com/AsahiLinux/u-boot/commit/84cd6c6e4149180e26c8d8f4827a1295ea3e000c.patch#/asahi-84cd6c6e4149180e26c8d8f4827a1295ea3e000c.patch
# arm: apple: Switch to standard boot
Patch132: https://github.com/AsahiLinux/u-boot/commit/206c84fc6055b3b1cf82db2e116701385de5f4df.patch#/asahi-206c84fc6055b3b1cf82db2e116701385de5f4df.patch
# arm: apple: Do not list bootflows on boot
Patch133: https://github.com/AsahiLinux/u-boot/commit/b15c4337c14cfdddff8e7ca72db6c8e2636a0ee7.patch#/asahi-b15c4337c14cfdddff8e7ca72db6c8e2636a0ee7.patch
# configs: apple: Do not show the boot menu automatically
Patch134: https://github.com/AsahiLinux/u-boot/commit/f22b3dee462e4f42abd01c409e70b81dee467845.patch#/asahi-f22b3dee462e4f42abd01c409e70b81dee467845.patch
# video: console: Parse UTF-8 character sequences
Patch135: https://github.com/AsahiLinux/u-boot/commit/9c1a720e6777cf794523d4379d35e6f255956dc5.patch#/asahi-9c1a720e6777cf794523d4379d35e6f255956dc5.patch
# lib/charset: Map Unicode code points to CP437 code points 1-31
Patch136: https://github.com/AsahiLinux/u-boot/commit/aaeff1f18f1707a46e8ce31877fbff0031697c26.patch#/asahi-aaeff1f18f1707a46e8ce31877fbff0031697c26.patch
# usb: xhci: refactor xhci_set_configuration
Patch137: https://github.com/AsahiLinux/u-boot/commit/d879a9627ccac56200f68266920c944e6dc01ecc.patch#/asahi-d879a9627ccac56200f68266920c944e6dc01ecc.patch
# usb: xhci: Set up endpoints for the first 2 interfaces
Patch138: https://github.com/AsahiLinux/u-boot/commit/c75dfb62a0f9d2a50e708c563ba3bea20d33eccd.patch#/asahi-c75dfb62a0f9d2a50e708c563ba3bea20d33eccd.patch
# usb: xhci: Abort transfers with unallocated rings
Patch139: https://github.com/AsahiLinux/u-boot/commit/689f4b6be67a543fd6d9043fd7c44aeca547fe95.patch#/asahi-689f4b6be67a543fd6d9043fd7c44aeca547fe95.patch
# usb: Add environment based device ignorelist
Patch140: https://github.com/AsahiLinux/u-boot/commit/2e5d86f26036aa867ea533b9f41f9c53f60bc3dd.patch#/asahi-2e5d86f26036aa867ea533b9f41f9c53f60bc3dd.patch
# usb: kbd: support Apple Magic Keyboards (2021)
Patch141: https://github.com/AsahiLinux/u-boot/commit/6a489a42c076a276455c38700f9d346ba9824b0e.patch#/asahi-6a489a42c076a276455c38700f9d346ba9824b0e.patch
# usb: kbd: Add probe quirk for Apple and Keychron keyboards
Patch142: https://github.com/AsahiLinux/u-boot/commit/9c5932734b13f3d2fc13ae3120ab1bdb334da383.patch#/asahi-9c5932734b13f3d2fc13ae3120ab1bdb334da383.patch
# video: console: Select default font based on video_priv.font_size
Patch143: https://github.com/AsahiLinux/u-boot/commit/31c0e5e8576f726d97772b94926680293ebb5302.patch#/asahi-31c0e5e8576f726d97772b94926680293ebb5302.patch
# video: simplefb: HACK: Set video font size
Patch144: https://github.com/AsahiLinux/u-boot/commit/ed7183f6d53b2df46752196ec3ff2d5bfe35d5b6.patch#/asahi-ed7183f6d53b2df46752196ec3ff2d5bfe35d5b6.patch
# fixup! usb: Pass through timeout to drivers
Patch145: https://github.com/AsahiLinux/u-boot/commit/d62ffcafa137b41385abe9d6272b4373e46a8602.patch#/asahi-d62ffcafa137b41385abe9d6272b4373e46a8602.patch
# FEDORA: configs: apple: Disable AUTOBOOT_KEYED
Patch146: https://github.com/AsahiLinux/u-boot/commit/c134629a8bc448e979967bf0632fdd5bb42ee1d7.patch#/asahi-c134629a8bc448e979967bf0632fdd5bb42ee1d7.patch

BuildRequires:  bc
BuildRequires:  bison
BuildRequires:  dtc
BuildRequires:  flex
BuildRequires:  gcc
BuildRequires:  gnutls-devel
BuildRequires:  libuuid-devel
BuildRequires:  make
BuildRequires:  ncurses-devel
BuildRequires:  openssl-devel
BuildRequires:  perl-interpreter
BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
BuildRequires:  python3-libfdt
BuildRequires:  SDL2-devel
BuildRequires:  swig
%if %{with toolsonly}
%ifarch aarch64
BuildRequires:  arm-trusted-firmware-armv8
BuildRequires:  python3-pyelftools
%endif
%endif
Requires:       dtc

%description
This package contains a few U-Boot utilities - mkimage for creating boot images
and fw_printenv/fw_setenv for manipulating the boot environment variables.

%if %{with toolsonly}
%ifarch aarch64
%package     -n uboot-images-armv8
Summary:     U-Boot firmware images for aarch64 boards
BuildArch:   noarch

%description -n uboot-images-armv8
U-Boot firmware binaries for aarch64 boards
%endif
%endif

%prep
%autosetup -p1 -n u-boot-%{version}%{?candidate:-%{candidate}}

cp %SOURCE1 .

%build
mkdir builds

%make_build HOSTCC="gcc $RPM_OPT_FLAGS" CROSS_COMPILE="" tools-only_defconfig O=builds/
%make_build HOSTCC="gcc $RPM_OPT_FLAGS" CROSS_COMPILE="" tools-all O=builds/

%if %{with toolsonly}
%ifarch aarch64
for board in $(cat %{_arch}-boards)
do
  echo "Building board: $board"
  mkdir builds/$(echo $board)/

  # ATF selection, needs improving, suggestions of ATF SoC to Board matrix welcome
  sun50i=(a64-olinuxino a64-olinuxino-emmc amarula_a64_relic bananapi_m2_plus_h5 bananapi_m64 libretech_all_h3_cc_h5 nanopi_a64 nanopi_neo2 nanopi_neo_plus2 oceanic_5205_5inmfd orangepi_pc2 orangepi_prime orangepi_win orangepi_zero_plus orangepi_zero_plus2 pine64-lts pine64_plus pinebook pinephone pinetab sopine_baseboard teres_i)
  if [[ " ${sun50i[*]} " == *" $board "* ]]; then
    echo "Board: $board using sun50i_a64"
    cp /usr/share/arm-trusted-firmware/sun50i_a64/bl31.bin builds/$(echo $board)/atf-bl31
  fi
  sun50h6=(beelink_gs1 emlid_neutis_n5_devboard orangepi_3 orangepi_lite2 orangepi_one_plus pine_h64 tanix_tx6)
  if [[ " ${sun50h6[*]} " == *" $board "* ]]; then
    echo "Board: $board using sun50i_h6"
    cp /usr/share/arm-trusted-firmware/sun50i_h6/bl31.bin builds/$(echo $board)/atf-bl31
  fi
  sun50i_h616=(orangepi_zero2 orangepi_zero3 transpeed-8k618-t x96_mate)
  if [[ " ${sun50i_h616[*]} " == *" $board "* ]]; then
    echo "Board: $board using sun50i_h616"
    cp /usr/share/arm-trusted-firmware/sun50i_h616/bl31.bin builds/$(echo $board)/atf-bl31
  fi
  rk3328=(evb-rk3328 nanopi-r2c-plus-rk3328 nanopi-r2c-rk3328 nanopi-r2s-rk3328 orangepi-r1-plus-lts-rk3328 orangepi-r1-plus-rk3328 roc-cc-rk3328 rock64-rk3328 rock-pi-e-rk3328)
  if [[ " ${rk3328[*]} " == *" $board "* ]]; then
    echo "Board: $board using rk3328"
    cp /usr/share/arm-trusted-firmware/rk3328/bl31.elf builds/$(echo $board)/atf-bl31
  fi
  rk3399=(eaidk-610-rk3399 evb-rk3399 ficus-rk3399 firefly-rk3399 khadas-edge-captain-rk3399 khadas-edge-rk3399 khadas-edge-v-rk3399 leez-rk3399 nanopc-t4-rk3399 nanopi-m4-2gb-rk3399 nanopi-m4b-rk3399 nanopi-m4-rk3399 nanopi-neo4-rk3399 nanopi-r4s-rk3399 orangepi-rk3399 pinebook-pro-rk3399 pinephone-pro-rk3399 puma-rk3399 rock960-rk3399 rock-pi-4c-rk3399 rock-pi-4-rk3399 rock-pi-n10-rk3399pro rockpro64-rk3399 roc-pc-mezzanine-rk3399 roc-pc-rk3399)
  if [[ " ${rk3399[*]} " == *" $board "* ]]; then
    echo "Board: $board using rk3399"
    cp /usr/share/arm-trusted-firmware/rk3399/* builds/$(echo $board)/
    cp builds/$(echo $board)/bl31.elf builds/$(echo $board)/atf-bl31
  fi
  # End ATF

  BINMAN_ALLOW_MISSING=1 make $(echo $board)_defconfig O=builds/$(echo $board)/
  BINMAN_ALLOW_MISSING=1 %make_build HOSTCC="gcc $RPM_OPT_FLAGS" CROSS_COMPILE="" O=builds/$(echo $board)/

done

%endif
%endif

%install
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_mandir}/man1
mkdir -p %{buildroot}%{_datadir}/uboot/

%if %{with toolsonly}
%ifarch aarch64
for board in $(ls builds)
do
 for file in u-boot.bin u-boot.img u-boot-dtb.img u-boot.itb u-boot-sunxi-with-spl.bin u-boot-rockchip-spi.bin u-boot-rockchip.bin idbloader.img idbloader-spi.img spl/boot.bin
 do
  if [ -f builds/$(echo $board)/$(echo $file) ]; then
    install -pD -m 0644 builds/$(echo $board)/$(echo $file) %{buildroot}%{_datadir}/uboot/$(echo $board)/$(echo $file)
  fi
 done
done

# For Apple M-series we also need the nodtb variant
install -pD -m 0644 builds/apple_m1/u-boot-nodtb.bin %{buildroot}%{_datadir}/uboot/apple_m1/u-boot-nodtb.bin

# Bit of a hack to remove binaries we don't use as they're large
for board in $(ls builds)
do
  rm -f %{buildroot}%{_datadir}/uboot/$(echo $board)/u-boot.dtb
  if [ -f %{buildroot}%{_datadir}/uboot/$(echo $board)/u-boot-sunxi-with-spl.bin ]; then
    rm -f %{buildroot}%{_datadir}/uboot/$(echo $board)/u-boot{,-dtb}.*
    rm -f %{buildroot}%{_datadir}/uboot/$(echo $board)/sunxi-spl.bin
  fi
  if [ -f %{buildroot}%{_datadir}/uboot/$(echo $board)/idbloader.img ]; then
    rm -f %{buildroot}%{_datadir}/uboot/$(echo $board)/u-boot.bin
    rm -f %{buildroot}%{_datadir}/uboot/$(echo $board)/u-boot{,-dtb}.img
  fi
done
%endif
%endif

for tool in dumpimage env/fw_printenv fit_check_sign fit_info gdb/gdbcont gdb/gdbsend gen_eth_addr gen_ethaddr_crc ifwitool img2srec kwboot mkeficapsule mkenvimage mkimage mksunxiboot ncb proftool sunxi-spl-image-builder
do
install -p -m 0755 builds/tools/$tool %{buildroot}%{_bindir}
done
install -p -m 0644 doc/mkimage.1 %{buildroot}%{_mandir}/man1

install -p -m 0755 builds/tools/env/fw_printenv %{buildroot}%{_bindir}
( cd %{buildroot}%{_bindir}; ln -sf fw_printenv fw_setenv )

%files
%doc README doc/develop/distro.rst doc/README.gpt
%doc doc/develop/uefi doc/usage doc/arch/arm64.rst
%{_bindir}/*
%{_mandir}/man1/mkimage.1*

%if %{with toolsonly}
%ifarch aarch64
%files -n uboot-images-armv8
%dir %{_datadir}/uboot/
%{_datadir}/uboot/*
%endif
%endif

%changelog
* Fri Apr 19 2024 Janne Grunau <janne-fdr@jannau.net> - 1:2024.04-4
- restore boot behavior on Apple silicon systems (disable AUTOBOOT_KEYED)

* Fri Apr 19 2024 Janne Grunau <janne-fdr@jannau.net> - 1:2024.04-3
- fix dwc2 build

* Thu Apr 18 2024 Janne Grunau <janne-fdr@jannau.net> - 1:2024.04-2
- Import Asahi Linux patches for Apple Silicon support

* Wed Apr 03 2024 Peter Robinson <pbrobinson@fedoraproject.org> - 1:2024.04-1
- Update to 2024.04 GA
- Rockchip rk3328 USB fixes

* Wed Mar 27 2024 Peter Robinson <pbrobinson@fedoraproject.org> - 1:2024.04-0.8.rc5
- Update to 2024.04 RC5

* Thu Mar 21 2024 Peter Robinson <pbrobinson@fedoraproject.org> - 1:2024.04-0.7.rc4
- Updated patch for DTB loading

* Fri Mar 15 2024 Peter Robinson <pbrobinson@fedoraproject.org> - 1:2024.04-0.6.rc4
- Updated fix for FDT load

* Wed Mar 13 2024 Peter Robinson <pbrobinson@fedoraproject.org> - 1:2024.04-0.5.rc4
- Fixes for Rockchip rk3399 autoboot

* Tue Mar 12 2024 Peter Robinson <pbrobinson@fedoraproject.org> - 1:2024.04-0.4.rc4
- Update to 2024.04 RC4
- Initial fix for loading DT off /boot (rhbz 2247873)

* Thu Feb 29 2024 Peter Robinson <pbrobinson@fedoraproject.org> - 1:2024.04-0.3.rc3
- Update to 2024.04 RC3
- Enable a number of new upstream devices
- Upstream now builds Rockchip SPI artifacts
- Various cleanups
- Fix ESP partition detection to enable EFI vars

* Wed Feb 14 2024 Peter Robinson <pbrobinson@fedoraproject.org> - 1:2024.04-0.2.rc2
- Update to 2024.04 RC2

* Sat Jan 27 2024 Fedora Release Engineering <releng@fedoraproject.org> - 1:2024.01-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Mon Jan 08 2024 Peter Robinson <pbrobinson@fedoraproject.org> - 1:2024.01-1
- Update to 2024.01

* Thu Dec 07 2023 Peter Robinson <pbrobinson@fedoraproject.org> - 1:2024.01-0.2.rc4
- Update to 2024.01 RC4
- Rebase SMBIOS patch to latest rev

* Fri Nov 24 2023 Peter Robinson <pbrobinson@fedoraproject.org> - 1:2024.01-0.1.rc3
- Update to 2024.01 RC3

* Tue Oct 31 2023 Peter Robinson <pbrobinson@fedoraproject.org> - 1:2023.10-0.9
- Rebuild

* Mon Oct 23 2023 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.10-0.8
- Further potential upstream fixes

* Mon Oct 02 2023 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.10-0.7
- Update to 2023.10 GA
- Some upstream fixes

* Mon Aug 21 2023 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.10-0.4.rc3
- Update to 2023.10 RC3

* Mon Aug 21 2023 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.10-0.3.rc2
- Add patch to speed up firmware UEFI video output

* Sat Aug 19 2023 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.10-0.2.rc2
- Add patch for Raspberry Pi boot

* Fri Aug 18 2023 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.10-0.1.rc2
- Update to 2023.10 RC2

* Sat Jul 22 2023 Fedora Release Engineering <releng@fedoraproject.org> - 2023.07-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Tue Jul 11 2023 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.07-1
- Update to 2023.07 GA

* Fri Jun 16 2023 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.07-0.4.rc4
- Disable NFS by default

* Mon Jun 12 2023 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.07-0.3.rc4
- Update to 2023.07 RC4

* Sun Jun 11 2023 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.07-0.2.rc3
- Update to 2023.07 RC3
- Fixes for the Pinephone Pro, RockPro64

* Wed May 17 2023 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.07-0.1.rc2
- Update to 2023.07 RC2

* Tue Apr 04 2023 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.04-1
- Update to 2023.04 GA

* Tue Mar 28 2023 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.04-0.4.rc5
- Update to 2023.04 RC5
- Drop upstreamed patches
- Rockchip boot fixes

* Tue Mar 14 2023 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.04-0.3.rc4
- Update to 2023.04 RC4

* Fri Feb 17 2023 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.04-0.2.rc2
- Update to 2023.04 RC2

* Tue Jan 31 2023 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.04-0.1.rc1
- Update to 2023.04 RC1
- Drop bmp_logo tool

* Sat Jan 21 2023 Fedora Release Engineering <releng@fedoraproject.org> - 2023.01-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Wed Jan 18 2023 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.01-1
- Update to 2023.01 GA

* Sat Dec 31 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.01-0.4.rc4
- Update PinePhone Pro to latest rev

* Tue Dec 20 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.01-0.3.rc4
- Update to 2023.01 RC4

* Mon Dec 05 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.01-0.2.rc3
- Update to 2023.01 RC3

* Thu Nov 24 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2023.01-0.1.rc2
- Update to U-Boot 2023.01 RC2
- Update Pinephone Pro patches

* Mon Oct 10 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.10-1
- Update to 2022.10 GA

* Tue Sep 06 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.10-0.6.rc4
- Update SMBIOS patch

* Tue Sep 06 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.10-0.5.rc4
- Update to 2022.10 RC4
- Fix for booting Rockchip devices from NVME

* Tue Aug 23 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.10-0.4.rc3
- Update to 2022.10 RC3

* Mon Aug 22 2022 Davide Cavalca <dcavalca@fedoraproject.org> - 2022.10-0.3.rc1
- Install nodtb variant for Apple M1 (rhbz#2068958)

* Tue Aug 16 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.10-0.2.rc1
- Fix for DT property propogation via firmware

* Thu Jul 28 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.10-0.1.rc1
- Update to 2022.10 RC1
- Enable LTO for firmware builds

* Sat Jul 23 2022 Fedora Release Engineering <releng@fedoraproject.org> - 2022.07-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Sun Jul 17 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.07-1
- Update to 2022.07 GA

* Mon Jul 04 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.07-0.6.rc6
- Update to 2022.07 RC6

* Mon Jun 20 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.07-0.5.rc5
- Update to 2022.07 RC5

* Sun Jun 12 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.07-0.4.rc4
- Update to 2022.07 RC4
- Some minor Rockchips device fixes

* Wed May 25 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.07-0.3.rc3
- Update to 2022.07 RC3

* Sat May 14 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.07-0.2.rc2
- Update to 2022.07 RC2

* Tue Apr 26 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.07-0.1.rc1
- Update to 2022.07 RC1

* Mon Apr 04 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.04-1
- Update to 2022.04 GA

* Mon Mar 28 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.04-0.4.rc5
- Update to 2022.04 RC5

* Tue Mar 08 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.04-0.3.rc3
- Update to 2022.04 RC3
- Enable new Rockchip devices

* Tue Feb 15 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.04-0.2.rc2
- Update to 2022.04 RC2

* Wed Feb 02 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.04-0.1.rc1
- Update to 2022.04 RC1

* Sat Jan 22 2022 Fedora Release Engineering <releng@fedoraproject.org> - 2022.01-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Mon Jan 10 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.01-1
- Update to 2022.01

* Wed Jan 05 2022 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.01-0.3.rc4
- Upstream fixes for PHY and UEFI

* Mon Dec 20 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.01-0.2.rc4
- Update to 2022.01 RC4

* Mon Nov 15 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2022.01-0.1.rc2
- Update to 2022.01 RC2

* Mon Nov 15 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.10-3
- Fixes for rk3399 devices

* Thu Oct 14 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.10-2
- Fix booting from MMC for Rockchip 3399 (rhbz #2014182)
- Enable new rk3399 devices (Leez, NanoPi-M4B, NanoPi-4S, NanoPi-T4) (rhbz #2009126)

* Mon Oct 04 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.10-1
- Update to 2021.10

* Mon Sep 27 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.10-0.7.rc5
- Update to 2021.10 RC5

* Wed Sep 15 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.10-0.6.rc4
- Update to 2021.10 RC4
- Proposed fix for RPi MMC clock issue

* Tue Sep 14 2021 Sahana Prasad <sahana@redhat.com> - 2021.10-0.6.rc3
- Rebuilt with OpenSSL 3.0.0

* Mon Aug 30 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.10-0.5.rc3
- Update to 2021.10 RC3

* Tue Aug 24 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.10-0.4.rc2
- Fix for Raspberry Pi firmware properties

* Mon Aug 23 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.10-0.3.rc2
- Fix for rockchip SPI

* Mon Aug 16 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.10-0.2.rc2
- Update to 2021.10 RC2

* Sun Aug 08 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.10-0.1.rc1
- Update to 2021.10 RC1

* Thu Jul 22 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.07-2
- Fix regression for Rockchip devices running firmware from SPI flash

* Mon Jul 05 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.07-1
- Update to 2021.07 GA

* Mon Jun 28 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.07-0.6.rc5
- Update to 2021.07 RC5
- Build SPI fash images for ROC-PC-RK3399

* Mon Jun 07 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.07-0.5.rc4
- Update to 2021.07 RC4

* Sat Jun 05 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.07-0.4.rc3
- Fix AllWinner devices booting from mSD/MMC

* Tue May 25 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.07-0.3.rc3
- Update to 2021.07 RC3
- Build against ATF 2.5 GA

* Thu May 13 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.07-0.2.rc2
- Build against new ATF 2.5-rc1

* Mon May 10 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.07-0.1.rc2
- Update to 2021.07 RC2

* Wed Apr 28 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.04-3
- Upstream fix for console regression (rhbz 1946278)
- Fix for fallback.efi crash (rhbz 1733817)

* Wed Apr 21 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.04-2
- Revert keyboard console regression change (rhbz 1946278)

* Sun Apr 18 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.04-1
- Update to 2021.04 GA
- Fix DTB load check (rhbz 1946278)
- Build Rockchip SPI support as idbloader.spi
- Fixes for Rockchip devices
- Build Turris Omnia for MMC/SPI/UART

* Wed Mar 17 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.04-0.6.rc4
- Update to 2021.04 RC4
- Move to upstream fix for SMP on RPi3B and RPi3B+

* Sat Mar 13 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.04-0.5.rc3
- Fix for SMP on RPi3B and RPi3B+
- Initial support for Pinephone 3Gb edition

* Mon Mar 08 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.04-0.4.rc3
- Update to 2021.04 RC3

* Tue Feb 16 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.04-0.3.rc2
- Update to 2021.04 RC2

* Mon Feb 15 2021 Dennis Gilmore <dennis@ausil.us>
- build spi and uart images in addition to mmc for helios4 and clearfog

* Wed Feb 10 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.04-0.2.rc1
- Fixes for network issues on some Allwinner devices

* Mon Feb 01 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.04-0.1.rc1
- Update to 2021.04 RC1
- Add new upstream devices

* Wed Jan 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 2021.01-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Mon Jan 11 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.01-1
- Update to 2021.01 GA
- Updates for Raspberry Pi 4 Series of devices

* Tue Jan  5 2021 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.01-0.5.rc5
- Update to 2021.01 RC5

* Sun Dec 27 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.01-0.4.rc4
- Update to 2021.01 RC4
- Latest RPi-400/CM4 support patch

* Tue Dec 15 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.01-0.3.rc3
- Update to 2021.01 RC3
- Latest RPi-400/CM4 support patch
- Re-enable previously disabled device support

* Mon Dec 14 2020 Javier Martinez Canillas <javierm@redhat.com> - 2021.01-0.2.rc2
- Fix a "scan_dev_for_efi" not defined error

* Sun Nov 22 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2021.01-0.1.rc2
- Update to 2021.01 RC2
- Latest Pinebook Pro display patches
- Initial RPi-400 support patch
- Update Fedora specific patches

* Sun Nov  8 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2020.10-3
- Fix SPI on Rockchip devices
- Latest Pinebook Pro display patches
- Fix Keyboard and USB-A ports on Pinebook Pro

* Wed Oct 28 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2020.10-2
- Fix kernel installs for non EBBR systems
- Fix for wired networks on some Allwinner devices

* Tue Oct 06 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2020.10-1
- Update to 2020.10

* Sun Sep 27 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2020.10-0.6.rc5
- Initial support for display output on Pinebook Pro

* Tue Sep 22 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2020.10-0.5.rc5
- Update to 2020.10 RC5

* Wed Sep 09 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2020.10-0.4.rc4
- Update to 2020.10 RC4

* Wed Aug 19 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2020.10-0.3.rc2
- Enable a number of new Rockchip devices

* Mon Aug 10 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2020.10-0.2.rc2
- Update to 2020.10 RC2

* Tue Jul 28 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2020.10-0.1.rc1
- 2020.10 RC1

* Tue Jul 14 2020 Tom Stellard <tstellar@redhat.com> - 2020.07-2
- Use make macros
- https://fedoraproject.org/wiki/Changes/UseMakeBuildInstallMacro

* Mon Jul 06 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2020.07-1
- 2020.07 GA

* Tue Jun 23 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2020.07-0.5.rc5
- 2020.07 RC5

* Thu Jun 18 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2020.07-0.4.rc4
- Update various patches to latest upstream

* Wed Jun 10 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2020.07-0.3.rc4
- 2020.07 RC4
- Minor updates and other fixes

* Tue May 12 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2020.07-0.2.rc2
- 2020.07 RC2
- Minor device updates

* Wed Apr 29 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2020.07-0.1.rc1
- 2020.07 RC1

* Tue Apr 21 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2020.04-4
- Initial support for USB on Rasperry Pi 4

* Tue Apr 21 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2020.04-3
- Ship u-boot-rockchip.bin for SPI flash

* Mon Apr 20 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2020.04-2
- Fix ATF for new aarch64 devices
- Fix Wandboard board detection (rhbz 1825247)
- Fix mSD card on RockPro64
- Enable (inital) Pinebook Pro

* Tue Apr 14 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 2020.04-1
- 2020.04

* Tue Apr  7 2020 Peter Robinson <pbrobinson@fedoraproject.org> 2020.04-0.7-rc5
- 2020.04 RC5

* Tue Mar 31 2020 Peter Robinson <pbrobinson@fedoraproject.org> 2020.04-0.6-rc4
- 2020.04 RC4
- Updates for NVIDIA Jetson platforms
- Support RNG for random seed for KASLR on some Rockchip devices

* Thu Mar 26 2020 Peter Robinson <pbrobinson@fedoraproject.org> 2020.04-0.5-rc3
- Fix ext4 alignment issue seen on some NXP i.MX devices

* Wed Feb 26 2020 Peter Robinson <pbrobinson@fedoraproject.org> 2020.04-0.4-rc3
- 2020.04 RC3

* Thu Feb 13 2020 Peter Robinson <pbrobinson@fedoraproject.org> 2020.04-0.3-rc2
- 2020.04 RC2

* Sun Feb  2 2020 Peter Robinson <pbrobinson@fedoraproject.org> 2020.04-0.2-rc1
- Update genet NIC driver

* Wed Jan 29 2020 Peter Robinson <pbrobinson@fedoraproject.org> 2020.04-0.1-rc1
- 2020.04 RC1

* Tue Jan  7 2020 Peter Robinson <pbrobinson@fedoraproject.org> 2020.01-1
- 2020.01
